const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Expansion_plansDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expansion_plans = await db.expansion_plans.create(
      {
        id: data.id || undefined,

        territory: data.territory || null,
        status: data.status || null,
        projected_roi_pct: data.projected_roi_pct || null,
        start_date: data.start_date || null,
        approval_status: data.approval_status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await expansion_plans.setOrganization(currentUser.organization.id || null, {
      transaction,
    });

    await expansion_plans.setOrganizations(data.organizations || null, {
      transaction,
    });

    return expansion_plans;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const expansion_plansData = data.map((item, index) => ({
      id: item.id || undefined,

      territory: item.territory || null,
      status: item.status || null,
      projected_roi_pct: item.projected_roi_pct || null,
      start_date: item.start_date || null,
      approval_status: item.approval_status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const expansion_plans = await db.expansion_plans.bulkCreate(
      expansion_plansData,
      { transaction },
    );

    // For each item created, replace relation files

    return expansion_plans;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const expansion_plans = await db.expansion_plans.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.territory !== undefined) updatePayload.territory = data.territory;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.projected_roi_pct !== undefined)
      updatePayload.projected_roi_pct = data.projected_roi_pct;

    if (data.start_date !== undefined)
      updatePayload.start_date = data.start_date;

    if (data.approval_status !== undefined)
      updatePayload.approval_status = data.approval_status;

    updatePayload.updatedById = currentUser.id;

    await expansion_plans.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await expansion_plans.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await expansion_plans.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return expansion_plans;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expansion_plans = await db.expansion_plans.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of expansion_plans) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of expansion_plans) {
        await record.destroy({ transaction });
      }
    });

    return expansion_plans;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const expansion_plans = await db.expansion_plans.findByPk(id, options);

    await expansion_plans.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await expansion_plans.destroy({
      transaction,
    });

    return expansion_plans;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const expansion_plans = await db.expansion_plans.findOne(
      { where },
      { transaction },
    );

    if (!expansion_plans) {
      return expansion_plans;
    }

    const output = expansion_plans.get({ plain: true });

    output.organization = await expansion_plans.getOrganization({
      transaction,
    });

    output.organizations = await expansion_plans.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.territory) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'expansion_plans',
            'territory',
            filter.territory,
          ),
        };
      }

      if (filter.projected_roi_pctRange) {
        const [start, end] = filter.projected_roi_pctRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            projected_roi_pct: {
              ...where.projected_roi_pct,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            projected_roi_pct: {
              ...where.projected_roi_pct,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.start_dateRange) {
        const [start, end] = filter.start_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            start_date: {
              ...where.start_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            start_date: {
              ...where.start_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.approval_status) {
        where = {
          ...where,
          approval_status: filter.approval_status,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.expansion_plans.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('expansion_plans', 'territory', query),
        ],
      };
    }

    const records = await db.expansion_plans.findAll({
      attributes: ['id', 'territory'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['territory', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.territory,
    }));
  }
};
